找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1709|回复: 0

[原创] 练习 绘制 RotatedDimension

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-28 08:06:26 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×

  1.         [CommandMethod("addrtd")]
  2.         public static void MyAddRotatedDim()
  3.         {
  4.             Document doc = Application.DocumentManager.MdiActiveDocument;
  5.             Editor ed = doc.Editor;
  6.             Database db = doc.Database;
  7.             Transaction tr = db.TransactionManager.StartTransaction();
  8.             PromptPointResult psr1 = ed.GetPoint("\nFirst Point");
  9.             if (psr1.Status != PromptStatus.OK) return;
  10.             PromptPointResult psr2 = ed.GetPoint("\nSecond Point");
  11.             if (psr2.Status != PromptStatus.OK) return;
  12.             PromptPointResult psr3 = ed.GetPoint("\nLocation");
  13.             if (psr3.Status != PromptStatus.OK) return;
  14.             using (tr)
  15.             {
  16.                 try
  17.                 {
  18.                     BlockTableRecord btr = (BlockTableRecord) tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
  19.                     Entity  rd = AddRotatedDimension(psr1.Value, psr2.Value, psr3.Value) as Entity ;
  20.                     
  21.                     btr.AppendEntity(rd);
  22.                     tr.AddNewlyCreatedDBObject(rd, true);
  23.                     tr.Commit();
  24.                 }
  25.                 catch (Exception)
  26.                 {
  27.                     throw;
  28.                 }
  29.             }
  30.         }
  31.         private static RotatedDimension AddRotatedDimension(Point3d p1, Point3d p2, Point3d p3)
  32.         {
  33.             Database db = Application.DocumentManager.MdiActiveDocument.Database;
  34.             ObjectId dst = db.Dimstyle;
  35.             Vector3d v = p1.GetVectorTo(p2);
  36.             Vector2d nv = new Vector2d(v.X, v.Y);
  37.             double an = nv.Angle;
  38.             return new RotatedDimension(an, p1, p2, p3, "", dst);
  39.         }

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-22 05:10 , Processed in 0.343234 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表